/***************************************************************************
 *   Copyright (C) 2008 by Gregor Montermann <g.montermann@mesytec.com>    *
 *   Copyright (C) 2009-2014 by Jens Krüger <jens.krueger@frm2.tum.de>     *
 *   Copyright (C) 2011-2014 by Lutz Rossa <rossa@helmholtz-berlin.de>     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _MDLLMAPCORRECT_H_
#define _MDLLMAPCORRECT_H_

#include "mapcorrect.h"

#include <QHash>

/**
 * \short this object represents user defined histogram mapping and correction data
 *
 * \author Jens Kr&uuml;ger <jens.krueger@frm2.tum.de>
 */
class LIBQMESYDAQ_EXPORT MdllMapCorrection : public LinearMapCorrection
{
public:
	//! default constructor
	MdllMapCorrection(void);

	/**
	 * constructor
	 *
	 * \param destSize target size
	 */
	MdllMapCorrection(const QSize &destSize);
};

class LIBQMESYDAQ_EXPORT Mdll2MapCorrection : public LinearMapCorrection
{
public:
	//! default constructor
	Mdll2MapCorrection(void);

	/**
	 * constructor
	 *
	 * \param destSize target size
	 */
	Mdll2MapCorrection(const QSize &destSize);
};

#endif 
